#!/bin/bash

  if [ $# -ne 3 ] # Wenn die Anzahl der Parameter (Wert in $#) ungleich 3 ist ...
  then
    # FARB-WERTE:
    RO="\033[31m"    # rot
    NO="\033[0m"     # normal   
    # echo -e "${RO}Syntax: $0 CSV-Datei-Pfad Feld-Trennzeichen Escape-Zeichen"
    echo -e "${RO}Syntax: $0 'CSV-File-Path' 'Field separator' 'Escape character'"
    exit 1
  fi

  # Sicherung der Variablen IFS in der Variablen backIFS (IFS = Internal Field Separator)
  backIFS=$IFS

  file_in=$1 # Parameter 1
  echo $file_in
  # Dateiname für file_out (XML-Datei) erzeugen
  filebasename=${file_in%.*}
  fileextension=".xml"
  file_out=$filebasename$fileextension
  echo $file_out

  separator=$2 # Parameter 2
  escape=$3    # Parameter 3

  # 1. Zeile (= Liste der Feld-Namen) aus CSV-Datei lesen 
  read header_line < "$file_in"
  IFS=$separator 
  # echo "IFS = $IFS"
  # Liste der Feld-Namen im Array 'header' speichern -> Operator =()
  header=($header_line)
  # echo "Anzahl der Elemente im Array 'header' : "${#header[@]}
  # Alle Elemente im Arrray 'header' ausgeben
  # echo "Elemente im Array 'header': "${header[*]}
  
  IFS='*'
  
  # Inhalt der CSV-Datei zeilenweise einlesen und im Array 'content' speichern
  i=0
  while read content[$i]
  do
    # echo "Zeile $i: ${content[i]}"
    ((i++))
  done < $1

  # 1. Zeile im Array 'content' löschen  
  unset content[0]
  # Array kopieren - aber ohne das jetzt leere erste Element
  content=(${content[*]})
  # Alle Elemente im Arrray 'content' ausgeben  
  # for record in ${content[@]}
  # do
  #   echo "ZEILE : "$record
  # done 

  # Inhalt der XML-Datei schreiben
  #-------------------------------------------------------------------------------
  # XML-Prolog
  echo '<?xml version="1.0" encoding="UTF-8"?>' > $file_out
  # XML-Root-Element
  echo '<Data>' >> $file_out
  # XML-Elemente
  #..............................................................
  for record in "${content[@]}"
  do
  echo '  <Record>' >> $file_out
    index=0
    #............................................................
    IFS=$separator list=($record)
    # echo "Anzahl aller Elemente im Array 'list' = "${#list[@]}
    # Alle Elemente im Arrray 'list' ausgeben
    # echo ${list[*]} 
    
    for (( c=0; c<=${#header[@]}-1; c++ ))
    do
      tag=${header[$c]#$escape}
      tag=${tag%$escape}
      value=${list[$c]#$escape}
      value=${value%$escape}
      echo '    <'${tag}'>'${value}'</'${tag}'>' >> $file_out
    done
    #............................................................
    echo '  </Record>' >> $file_out
    ((index++))
  done 
  #-------------------------------------------------------------------------------
  
  echo '</Data>' >> $file_out
  IFS=$backIFS

  # sleep 2s
  # cat $file_out

  exit 0

